*cd "C:\Shazam\AER"
cd "C:\Users\tim\Documents\AAA-economics\aaaa-People-current\denis lawrence\AER 2013-2018\Jan 2019"

log using "vc-out-med-BM-uga-2-2-19", replace

* AER VC SFA model and CIs
* Australia & NZ updated 1 year to 2017, Ontario updated 1 year to 2016
* use new Ontario spec taking account of amalgamations
* This version to look at UG elasticities, etc. for log-log and log-lin
* Also does non-nested tests and AIC and BIC
* Data runs 2006-2017
version 11
clear
set more off
set maxiter 200
set matsize 800


* import excel "DNSPData AusNZOnt 1Nov2018x BM.xls", sheet("DNSP Med") firstrow
insheet using "DNSPData AusNZOnt 1Nov2018x BM.txt"
* variables are: EIID Year Country Opex PrOpex MaxDem RMDemand CustNum CircLen ShareUGC

summarize
correlate custnum circlen rmdemand

generate DNSP=0
replace DNSP=int(eiid/100) if country==1
replace DNSP=eiid-2000+13 if country==2
replace DNSP=eiid-3000+36 if country==3

xtset DNSP year

* adjust to calendar year
generate yr=year
replace yr=yr+0.5 if DNSP==3
replace yr=yr+0.5 if DNSP==8
replace yr=yr+0.5 if DNSP==9
replace yr=yr+0.5 if DNSP==11
replace yr=yr+0.5 if DNSP==13
replace yr=yr-0.25 if country==2
replace yr=yr+0.5 if country==3

* adjust base to 2012
replace propex=propex/1.242220559 if country==1
replace propex=propex/1.221665248 if country==2
replace propex=propex/1.162050691 if country==3

* adjust for PPPs in 2012
* Australia PPP = 1.527404363
* NZ PPP = 1.482877481
* Canada PPP = 1.249076963
* converting into Australian Dollar base
replace propex=propex*1.482877481/1.527404363 if country==2
replace propex=propex*1.249076963/1.527404363 if country==3

generate vc=opex/propex
generate lvc=log(vc)

generate ly2=log(custnum)
generate ly3=log(circlen)
generate ly4=log(rmdemand)

generate z1=shareugc

generate lz1=log(z1)

* mean correct output data
qui reg ly2
predict mly2
replace ly2=ly2-mly2
qui reg ly3
predict mly3
replace ly3=ly3-mly3
qui reg ly4
predict mly4
replace ly4=ly4-mly4

generate cd2=0
replace cd2=1 if country==2
generate cd3=0
replace cd3=1 if country==3

generate ly1=0
generate ly22=ly2*ly2/2
generate ly33=ly3*ly3/2
generate ly44=ly4*ly4/2
generate ly23=ly2*ly3
generate ly24=ly2*ly4
generate ly34=ly3*ly4

* construct dummy variables
qui tabulate DNSP, gen(d)

* models with log-log UG:

xtfrontier lvc ly2-ly4 lz1 yr cd2 cd3, ti cost 
estat ic
predict lvcp
generate vcp=exp(lvcp)
matrix b=e(b)
matrix list b 

xtpcse lvc ly2-ly4 lz1 yr cd2 cd3 d1-d8 d10-d13, c(a) het
predict lvcp3
generate vcp3=exp(lvcp3)
matrix b3=e(b)
matrix list b3 

regress lvc ly2-ly4 lz1 yr cd2 cd3 d1-d8 d10-d13
estat ic

* check that replacing log(shareugc) with log(ugc) provides same estimated model:

generate lugc=log(shareugc*circlen)
regress lvc ly2-ly4 lugc yr cd2 cd3 d1-d8 d10-d13
estat ic

* models with log-lin UG:

xtfrontier lvc ly2-ly4 z1 yr cd2 cd3, ti cost 
estat ic
predict lvcp2
generate vcp2=exp(lvcp2)
matrix b2=e(b)
matrix list b2 

xtpcse lvc ly2-ly4 z1 yr cd2 cd3 d1-d8 d10-d13, c(a) het
predict lvcp4
generate vcp4=exp(lvcp4)
matrix b4=e(b)
matrix list b4

regress lvc ly2-ly4 z1 yr cd2 cd3 d1-d8 d10-d13
estat ic

* nested model for non-nested testing

xtfrontier lvc ly2-ly4 lz1 z1 yr cd2 cd3, ti cost 

xtpcse lvc ly2-ly4 lz1 z1 yr cd2 cd3 d1-d8 d10-d13, c(a) het

regress lvc ly2-ly4 lz1 z1 yr cd2 cd3 d1-d8 d10-d13


* LSE calculations:

* we generate efficient frontier opex predictions excluding dummy var coeffs
* note in in above model estimations we omitted the d9 dummy because it was most efficient

drop if country>1
drop if year < 2017

generate ug=circlen*shareug
generate con=1

mkmat ly2
mkmat ly3
mkmat ly4
mkmat lz1
mkmat z1
mkmat yr
mkmat con

matrix lvcp3f=b3[1,1]*ly2+b3[1,2]*ly3+b3[1,3]*ly4+b3[1,4]*lz1+b3[1,5]*yr+b3[1,20]*con
svmat lvcp3f

matrix lvcp4f=b4[1,1]*ly2+b4[1,2]*ly3+b4[1,3]*ly4+b4[1,4]*z1+b4[1,5]*yr+b4[1,20]*con
svmat lvcp4f

* now we check that the above prediction calculations worked correctly

generate tmp3=lvcp3f-lvcp3
generate tmp4=lvcp4f-lvcp4
list tmp3 tmp4

generate vcp3f=exp(lvcp3f)
generate vcp4f=exp(lvcp4f)

list DNSP year custnum circlen rmdemand shareugc 
list DNSP year vcp vcp2 vcp3f vcp4f

log close


